# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ListEffectiveConfigurationResult',
    'AwaitableListEffectiveConfigurationResult',
    'list_effective_configuration',
]

@pulumi.output_type
class ListEffectiveConfigurationResult:
    """
    Result of the request to list networkManagerEffectiveConfiguration. It contains a list of groups and a URL link to get the next set of results.
    """
    def __init__(__self__, skip_token=None, value=None):
        if skip_token and not isinstance(skip_token, str):
            raise TypeError("Expected argument 'skip_token' to be a str")
        pulumi.set(__self__, "skip_token", skip_token)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="skipToken")
    def skip_token(self) -> Optional[str]:
        """
        When present, the value can be passed to a subsequent query call (together with the same query and scopes used in the current request) to retrieve the next page of data.
        """
        return pulumi.get(self, "skip_token")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence[Any]]:
        """
        Gets a page of NetworkManagerEffectiveConfiguration
        """
        return pulumi.get(self, "value")


class AwaitableListEffectiveConfigurationResult(ListEffectiveConfigurationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListEffectiveConfigurationResult(
            skip_token=self.skip_token,
            value=self.value)


def list_effective_configuration(resource_group_name: Optional[str] = None,
                                 skip_token: Optional[str] = None,
                                 virtual_network_name: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListEffectiveConfigurationResult:
    """
    Result of the request to list networkManagerEffectiveConfiguration. It contains a list of groups and a URL link to get the next set of results.
    API Version: 2021-02-01-preview.


    :param str resource_group_name: The name of the resource group.
    :param str skip_token: When present, the value can be passed to a subsequent query call (together with the same query and scopes used in the current request) to retrieve the next page of data.
    :param str virtual_network_name: The name of the virtual network.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['skipToken'] = skip_token
    __args__['virtualNetworkName'] = virtual_network_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('azure-native:network:listEffectiveConfiguration', __args__, opts=opts, typ=ListEffectiveConfigurationResult).value

    return AwaitableListEffectiveConfigurationResult(
        skip_token=__ret__.skip_token,
        value=__ret__.value)
