# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AlertRuleKind',
    'AlertSeverity',
    'AttackTactic',
    'AutomationRuleActionType',
    'AutomationRuleConditionType',
    'AutomationRulePropertyConditionSupportedOperator',
    'AutomationRulePropertyConditionSupportedProperty',
    'CaseSeverity',
    'ContentType',
    'CustomEntityQueryKind',
    'DataConnectorKind',
    'DataTypeState',
    'EntityTimelineKind',
    'EntityType',
    'IncidentClassification',
    'IncidentClassificationReason',
    'IncidentSeverity',
    'IncidentStatus',
    'Kind',
    'MicrosoftSecurityProductName',
    'Operator',
    'RepoType',
    'SettingKind',
    'Source',
    'SourceKind',
    'SupportTier',
    'ThreatIntelligenceResourceKind',
    'TriggerOperator',
    'TriggersOn',
    'TriggersWhen',
    'UebaDataSources',
]


class AlertRuleKind(str, Enum):
    """
    The alert rule kind
    """
    SCHEDULED = "Scheduled"
    MICROSOFT_SECURITY_INCIDENT_CREATION = "MicrosoftSecurityIncidentCreation"
    FUSION = "Fusion"


class AlertSeverity(str, Enum):
    """
    The severity for alerts created by this alert rule.
    """
    HIGH = "High"
    MEDIUM = "Medium"
    LOW = "Low"
    INFORMATIONAL = "Informational"


class AttackTactic(str, Enum):
    """
    The severity for alerts created by this alert rule.
    """
    INITIAL_ACCESS = "InitialAccess"
    EXECUTION = "Execution"
    PERSISTENCE = "Persistence"
    PRIVILEGE_ESCALATION = "PrivilegeEscalation"
    DEFENSE_EVASION = "DefenseEvasion"
    CREDENTIAL_ACCESS = "CredentialAccess"
    DISCOVERY = "Discovery"
    LATERAL_MOVEMENT = "LateralMovement"
    COLLECTION = "Collection"
    EXFILTRATION = "Exfiltration"
    COMMAND_AND_CONTROL = "CommandAndControl"
    IMPACT = "Impact"


class AutomationRuleActionType(str, Enum):
    """
    The type of the automation rule action
    """
    MODIFY_PROPERTIES = "ModifyProperties"
    RUN_PLAYBOOK = "RunPlaybook"


class AutomationRuleConditionType(str, Enum):
    """
    The type of the automation rule condition
    """
    PROPERTY = "Property"


class AutomationRulePropertyConditionSupportedOperator(str, Enum):
    """
    The operator to use for evaluation the condition
    """
    EQUALS = "Equals"
    NOT_EQUALS = "NotEquals"
    CONTAINS = "Contains"
    NOT_CONTAINS = "NotContains"
    STARTS_WITH = "StartsWith"
    NOT_STARTS_WITH = "NotStartsWith"
    ENDS_WITH = "EndsWith"
    NOT_ENDS_WITH = "NotEndsWith"


class AutomationRulePropertyConditionSupportedProperty(str, Enum):
    """
    The property to evaluate
    """
    INCIDENT_TITLE = "IncidentTitle"
    INCIDENT_DESCRIPTION = "IncidentDescription"
    INCIDENT_SEVERITY = "IncidentSeverity"
    INCIDENT_STATUS = "IncidentStatus"
    INCIDENT_TACTICS = "IncidentTactics"
    INCIDENT_RELATED_ANALYTIC_RULE_IDS = "IncidentRelatedAnalyticRuleIds"
    INCIDENT_PROVIDER_NAME = "IncidentProviderName"
    ACCOUNT_AAD_TENANT_ID = "AccountAadTenantId"
    ACCOUNT_AAD_USER_ID = "AccountAadUserId"
    ACCOUNT_NAME = "AccountName"
    ACCOUNT_NT_DOMAIN = "AccountNTDomain"
    ACCOUNT_PUID = "AccountPUID"
    ACCOUNT_SID = "AccountSid"
    ACCOUNT_OBJECT_GUID = "AccountObjectGuid"
    ACCOUNT_UPN_SUFFIX = "AccountUPNSuffix"
    AZURE_RESOURCE_RESOURCE_ID = "AzureResourceResourceId"
    AZURE_RESOURCE_SUBSCRIPTION_ID = "AzureResourceSubscriptionId"
    CLOUD_APPLICATION_APP_ID = "CloudApplicationAppId"
    CLOUD_APPLICATION_APP_NAME = "CloudApplicationAppName"
    DNS_DOMAIN_NAME = "DNSDomainName"
    FILE_DIRECTORY = "FileDirectory"
    FILE_NAME = "FileName"
    FILE_HASH_VALUE = "FileHashValue"
    HOST_AZURE_ID = "HostAzureID"
    HOST_NAME = "HostName"
    HOST_NET_BIOS_NAME = "HostNetBiosName"
    HOST_NT_DOMAIN = "HostNTDomain"
    HOST_OS_VERSION = "HostOSVersion"
    IO_T_DEVICE_ID = "IoTDeviceId"
    IO_T_DEVICE_NAME = "IoTDeviceName"
    IO_T_DEVICE_TYPE = "IoTDeviceType"
    IO_T_DEVICE_VENDOR = "IoTDeviceVendor"
    IO_T_DEVICE_MODEL = "IoTDeviceModel"
    IO_T_DEVICE_OPERATING_SYSTEM = "IoTDeviceOperatingSystem"
    IP_ADDRESS = "IPAddress"
    MAILBOX_DISPLAY_NAME = "MailboxDisplayName"
    MAILBOX_PRIMARY_ADDRESS = "MailboxPrimaryAddress"
    MAILBOX_UPN = "MailboxUPN"
    MAIL_MESSAGE_DELIVERY_ACTION = "MailMessageDeliveryAction"
    MAIL_MESSAGE_DELIVERY_LOCATION = "MailMessageDeliveryLocation"
    MAIL_MESSAGE_RECIPIENT = "MailMessageRecipient"
    MAIL_MESSAGE_SENDER_IP = "MailMessageSenderIP"
    MAIL_MESSAGE_SUBJECT = "MailMessageSubject"
    MAIL_MESSAGE_P1_SENDER = "MailMessageP1Sender"
    MAIL_MESSAGE_P2_SENDER = "MailMessageP2Sender"
    MALWARE_CATEGORY = "MalwareCategory"
    MALWARE_NAME = "MalwareName"
    PROCESS_COMMAND_LINE = "ProcessCommandLine"
    PROCESS_ID = "ProcessId"
    REGISTRY_KEY = "RegistryKey"
    REGISTRY_VALUE_DATA = "RegistryValueData"
    URL = "Url"


class CaseSeverity(str, Enum):
    """
    The severity of the incident
    """
    CRITICAL = "Critical"
    HIGH = "High"
    MEDIUM = "Medium"
    LOW = "Low"
    INFORMATIONAL = "Informational"


class ContentType(str, Enum):
    """
    Content type.
    """
    ANALYTIC_RULE = "AnalyticRule"
    WORKBOOK = "Workbook"


class CustomEntityQueryKind(str, Enum):
    """
    the entity query kind
    """
    ACTIVITY = "Activity"


class DataConnectorKind(str, Enum):
    """
    The data connector kind
    """
    AZURE_ACTIVE_DIRECTORY = "AzureActiveDirectory"
    AZURE_SECURITY_CENTER = "AzureSecurityCenter"
    MICROSOFT_CLOUD_APP_SECURITY = "MicrosoftCloudAppSecurity"
    THREAT_INTELLIGENCE = "ThreatIntelligence"
    OFFICE365 = "Office365"
    AMAZON_WEB_SERVICES_CLOUD_TRAIL = "AmazonWebServicesCloudTrail"
    AZURE_ADVANCED_THREAT_PROTECTION = "AzureAdvancedThreatProtection"
    MICROSOFT_DEFENDER_ADVANCED_THREAT_PROTECTION = "MicrosoftDefenderAdvancedThreatProtection"


class DataTypeState(str, Enum):
    """
    Describe whether this data type connection is enabled or not.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class EntityTimelineKind(str, Enum):
    """
    The entity query kind
    """
    ACTIVITY = "Activity"
    BOOKMARK = "Bookmark"
    SECURITY_ALERT = "SecurityAlert"


class EntityType(str, Enum):
    """
    The type of the query's source entity
    """
    ACCOUNT = "Account"
    HOST = "Host"
    FILE = "File"
    AZURE_RESOURCE = "AzureResource"
    CLOUD_APPLICATION = "CloudApplication"
    DNS = "DNS"
    FILE_HASH = "FileHash"
    IP = "IP"
    MALWARE = "Malware"
    PROCESS = "Process"
    REGISTRY_KEY = "RegistryKey"
    REGISTRY_VALUE = "RegistryValue"
    SECURITY_GROUP = "SecurityGroup"
    URL = "URL"
    IO_T_DEVICE = "IoTDevice"
    SECURITY_ALERT = "SecurityAlert"
    HUNTING_BOOKMARK = "HuntingBookmark"
    MAIL_CLUSTER = "MailCluster"
    MAIL_MESSAGE = "MailMessage"
    MAILBOX = "Mailbox"
    SUBMISSION_MAIL = "SubmissionMail"


class IncidentClassification(str, Enum):
    """
    The reason the incident was closed
    """
    UNDETERMINED = "Undetermined"
    TRUE_POSITIVE = "TruePositive"
    BENIGN_POSITIVE = "BenignPositive"
    FALSE_POSITIVE = "FalsePositive"


class IncidentClassificationReason(str, Enum):
    """
    The classification reason the incident was closed with
    """
    SUSPICIOUS_ACTIVITY = "SuspiciousActivity"
    SUSPICIOUS_BUT_EXPECTED = "SuspiciousButExpected"
    INCORRECT_ALERT_LOGIC = "IncorrectAlertLogic"
    INACCURATE_DATA = "InaccurateData"


class IncidentSeverity(str, Enum):
    """
    The severity of the incident
    """
    HIGH = "High"
    MEDIUM = "Medium"
    LOW = "Low"
    INFORMATIONAL = "Informational"


class IncidentStatus(str, Enum):
    """
    The status of the incident
    """
    NEW = "New"
    ACTIVE = "Active"
    CLOSED = "Closed"


class Kind(str, Enum):
    """
    The kind of content the metadata is for.
    """
    DATA_CONNECTOR = "DataConnector"
    DATA_TYPE = "DataType"
    WORKBOOK = "Workbook"
    WORKBOOK_TEMPLATE = "WorkbookTemplate"
    PLAYBOOK = "Playbook"
    PLAYBOOK_TEMPLATE = "PlaybookTemplate"
    ANALYTICS_RULE_TEMPLATE = "AnalyticsRuleTemplate"
    ANALYTICS_RULE = "AnalyticsRule"
    HUNTING_QUERY = "HuntingQuery"
    INVESTIGATION_QUERY = "InvestigationQuery"
    PARSER = "Parser"
    WATCHLIST = "Watchlist"
    WATCHLIST_TEMPLATE = "WatchlistTemplate"
    SOLUTION = "Solution"


class MicrosoftSecurityProductName(str, Enum):
    """
    The alerts' productName on which the cases will be generated
    """
    MICROSOFT_CLOUD_APP_SECURITY = "Microsoft Cloud App Security"
    AZURE_SECURITY_CENTER = "Azure Security Center"
    AZURE_ADVANCED_THREAT_PROTECTION = "Azure Advanced Threat Protection"
    AZURE_ACTIVE_DIRECTORY_IDENTITY_PROTECTION = "Azure Active Directory Identity Protection"
    AZURE_SECURITY_CENTER_FOR_IO_T = "Azure Security Center for IoT"


class Operator(str, Enum):
    """
    Operator used for list of dependencies in criteria array.
    """
    AND_ = "AND"
    OR_ = "OR"


class RepoType(str, Enum):
    """
    The repository type of the source control
    """
    GITHUB = "Github"
    DEV_OPS = "DevOps"


class SettingKind(str, Enum):
    """
    The kind of the setting
    """
    EYES_ON = "EyesOn"
    ENTITY_ANALYTICS = "EntityAnalytics"
    UEBA = "Ueba"


class Source(str, Enum):
    """
    The source of the watchlist
    """
    LOCAL_FILE = "Local file"
    REMOTE_STORAGE = "Remote storage"


class SourceKind(str, Enum):
    """
    Source type of the content
    """
    LOCAL_WORKSPACE = "LocalWorkspace"
    COMMUNITY = "Community"
    SOLUTION = "Solution"
    SOURCE_REPOSITORY = "SourceRepository"


class SupportTier(str, Enum):
    """
    Type of support for content item
    """
    MICROSOFT = "Microsoft"
    PARTNER = "Partner"
    COMMUNITY = "Community"


class ThreatIntelligenceResourceKind(str, Enum):
    """
    The kind of the entity.
    """
    INDICATOR = "indicator"


class TriggerOperator(str, Enum):
    """
    The operation against the threshold that triggers alert rule.
    """
    GREATER_THAN = "GreaterThan"
    LESS_THAN = "LessThan"
    EQUAL = "Equal"
    NOT_EQUAL = "NotEqual"


class TriggersOn(str, Enum):
    """
    The type of object the automation rule triggers on
    """
    INCIDENTS = "Incidents"


class TriggersWhen(str, Enum):
    """
    The type of event the automation rule triggers on
    """
    CREATED = "Created"


class UebaDataSources(str, Enum):
    """
    The data source that enriched by ueba.
    """
    AUDIT_LOGS = "AuditLogs"
    AZURE_ACTIVITY = "AzureActivity"
    SECURITY_EVENT = "SecurityEvent"
    SIGNIN_LOGS = "SigninLogs"
